/** \file CahnHilliard.h */

#ifndef CAHN_HILLIARD_H
#define CAHN_HILLIARD_H

#include "AMDiS.h"
#include "BaseProblem.h"
#include "ExtendedProblemStat.h"
#include "chns.h"

using namespace AMDiS;

class CahnHilliard : public BaseProblem<ExtendedProblemStat>
{
public: // definition of types

  typedef BaseProblem<ExtendedProblemStat> super;

public: // public methods

  CahnHilliard(const std::string &name_);
  ~CahnHilliard();

  virtual void initData() {};
  virtual void solveInitialProblem(AdaptInfo *adaptInfo);

  double getEpsilon() { return eps; }
  int getDoubleWellType() { return doubleWell; }

protected: // protected methods

  virtual void fillOperators();
  virtual void fillBoundaryConditions() {}

protected: // protected variables

  bool useMobility;

  unsigned dim;

  int doubleWell;

  double gamma;
  double eps;
  double minusEps;
  double epsInv;
  double minusEpsInv;
  double epsSqr;
  double minusEpsSqr;
};

#endif // CAHN_HILLIARD_H
